package de.fhdw.wtf.generator.java.walker;

import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.DependencyTask;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.generator.java.generatorModel.GenClassClass;
import de.fhdw.wtf.generator.java.generatorModel.GenInterfaceClass;
import de.fhdw.wtf.generator.java.generatorModel.GenOperation;

public abstract class GeneratorModelWalkerTask extends DependencyTask {
	
	public GeneratorModelWalkerTask(final TaskExecutor taskmanager) {
		super(taskmanager);
	}
	
	public abstract void handleClassClass(GenClassClass cc) throws TaskException;
	
	public abstract void handleInterfaceClass(GenInterfaceClass ic) throws TaskException;
	
	public abstract void handleOperation(GenOperation o) throws TaskException;
	
}
